import javax.swing.*;
import java.awt.*;
import java.awt.event.*;
import java.util.*;
import java.io.*;
import java.net.*;


public class ServerPlot extends JFrame implements ActionListener{
   final static int SERVER_PORT=8010;
   final static int MAX_ROW=10,MAX_COL=10,SIZE=4;
   JTextField jtf;
   ImageIcon icon;
   String str;
   JLabel jl;
   JButton b[][]=new JButton[MAX_ROW][MAX_COL];
   static Server server;
   String clientRequest,response;
   BufferedReader br;
   PrintWriter writer;
   int height[]=new int[MAX_ROW];
   int countClient=0,countServer=0;

   public void init(){
      JFrame f=new JFrame();

      f.addWindowListener(new WindowAdapter() {
        public void windowClosing(WindowEvent e) {
           setVisible(false);
           System.exit(0);
        }
      });

      br =new BufferedReader(new InputStreamReader (server.in));

      Container contentPane=f.getContentPane();
      contentPane.setLayout(new GridBagLayout());
      GridBagConstraints gbc=new GridBagConstraints();

      icon=new ImageIcon("T.jpg");

      gbc.gridwidth=1;
      gbc.gridheight=1;
      gbc.gridx=0;
      gbc.gridy=0;
      gbc.fill=GridBagConstraints.BOTH;

    for(int y=0;y<MAX_ROW;y++){
   for(int x=0;x<MAX_COL;x++){
      gbc.gridx=x;
      gbc.gridy=y+2;
      b[y][x]=new JButton(icon);
      b[y][x].setActionCommand(""+x);
            b[y][x].addActionListener(this);
           contentPane.add(b[y][x],gbc);
   }
      }


      gbc.gridx=3;
      gbc.gridy=MAX_ROW+2;
      gbc.gridwidth=3;
      jtf=new JTextField("Client's Turn",15);
      contentPane.add(jtf,gbc);

      gbc.gridwidth=10;
      gbc.gridx=0;
      gbc.gridy=0;

      icon=new ImageIcon("pfserv.jpg");
      JLabel jl=new JLabel(icon);
        contentPane.add(jl,gbc);


      f.setSize(600,600);
      f.setVisible(true);
      f.show();

      while(true){
         try{
            if(countServer==countClient){
               clientRequest=br.readLine();
               countClient++;
               icon=new ImageIcon("cross.jpg");
             try{
                  int i=Integer.parseInt(clientRequest);
                  int j=height[Integer.parseInt(clientRequest)];

                  b[j][i].setIcon(icon);
                  b[j][i].setActionCommand("cross");
                  b[j][i].removeActionListener(this);
                  height[Integer.parseInt(clientRequest)]++;


               }catch(NumberFormatException e){
                  try{
                     int i=Integer.parseInt(clientRequest.substring(0,1));
                     int j=height[Integer.parseInt(clientRequest.substring(0,1))];
                     clientRequest="Client has won !!!";
                     b[j][i].setIcon(icon);
                     b[j][i].removeActionListener(this);
                     jtf.setText("Client has won !!!");
                     stopProgram();
                     break;
                  }catch(NumberFormatException nfe){
                     clientRequest="Server has won !!!";

                     stopProgram();
                     jtf.setText("Server has won !!!");
                     break;

                  }
               }
               jtf.setText("Server's Turn");
            }
         }catch(IOException e){}

   }
   }

   public void stopProgram(){
      for(int x=0;x<MAX_COL;x++)
         for (int y=0;y<MAX_ROW;y++)
            b[y][x].removeActionListener(this);
   }

   public void actionPerformed(ActionEvent ae){
      if(countClient==countServer)
         return;

      if (height[Integer.parseInt(ae.getActionCommand())]==MAX_ROW)
         return;


      int j=height[Integer.parseInt(ae.getActionCommand())];
      countServer++;

      writer =new PrintWriter(new OutputStreamWriter (server.out),true);
      jtf.setText("Client's Turn");
      icon=new ImageIcon("not.jpg");
      int i=Integer.parseInt(ae.getActionCommand());
      b[j][i].setIcon(icon);
      b[j][i].setActionCommand("not");
      b[j][i].removeActionListener(this);
      height[Integer.parseInt(ae.getActionCommand())]++;
         writer.println(ae.getActionCommand());

  }

public static void main(String args[]){


   server =new Server(SERVER_PORT);
   new ServerPlot().init();
   }
}
   class Server {
      private ServerSocket server;
      public Socket socket;

      public InputStream in;
      public OutputStream out;

      public Server (int port){

         try {
            server =new ServerSocket (port);
            System.out.println("ServerSocket before accept:"+server);
            System.out.println("java test server v0.03,on-line!");

            socket=server.accept();
            System.out.println("ServerSocket after accept:"+server);

            in  =socket.getInputStream();
            out =socket.getOutputStream();


         } catch (IOException e) {
         System.out.println("Server constructor IOEx:"+ e);
         }
      }
   }

